<?php
/**
 * Created by PhpStorm.
 * User: matheussilva
 * Date: 31/10/14
 * Time: 09:59
 */

namespace Folha\Logic\ImportacaoLoteEvento;


class Exception extends \Exception
{
    const ERRO  = 1111;
    const AVISO = 1110;

    public static function funcionarioInvalido($funcionario)
    {
       return new self("O código do funcionário $funcionario está incorreto", self::ERRO);
    }

    public static function eventoInvalido($evento)
    {
        return new self("O código do funcionário $evento está incorreto", self::ERRO);
    }

    public static function valorInvalido($evento, $funcionario)
    {
        return new self("O valor informado para o evento $evento do vínculo $funcionario é inválido", self::ERRO);
    }

    public static function dataCompetenciaInvalido()
    {
        return new self("Data de Competência inválida", self::ERRO);
    }

    public static function extensaoInvalida()
    {
        return new self("Extensão de arquivo não aceita", self::ERRO);
    }

    public static function funcionarioInexistente($funcionario)
    {
        return new self("O funcionário $funcionario não existe ou seu código está incorreto", self::ERRO);
    }

    public static function dataCompetenciaIncorreta()
    {
        return new self("A Data de Competência do arquivo diferente da Data de Competência do sistema", self::ERRO);
    }

    public static function semEventos()
    {
        return new self("Não existem eventos para serem importados ou o template está incorrento", self::ERRO);
    }

    public static function eventoInexistente($codEvento)
    {
        return new self("Não existe o evento $codEvento", self::ERRO);
    }

    public static function infoInvalida()
    {
        return new self("Informações ou layout do arquivo inválidos", self::ERRO);
    }

    public static function lerArquivo()
    {
        return new self("Erro ao abrir ou ler o arquivo", self::ERRO);
    }

    public static function fazerDownload()
    {
        return new self("Erro ao tentar fazer download do arquivo", self::ERRO);
    }

    public static function semVinculos()
    {
        return new self("Não existem vínculos na planílha ou layout do arquivo é inválido", self::ERRO);
    }
}